Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/simplify.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/simplify.cpp	(revision 1007)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/simplify.cpp	(revision 2090)
@@ -554,2 +593,479 @@
 }
 
+///////////////////////////////////////////////////////////////////////////////
+//	Extract a correct edge of the heap.
+///////////////////////////////////////////////////////////////////////////////
+int VMI::extractValidEdge(Mesh *mesh,	bheap_t *h)
+{
+	int	e;
+
+	while((e	=	isValidEdge(mesh,getMinEdge(mesh, h))) == -1);
+
+	return	e;
+}
+
+///////////////////////////////////////////////////////////////////////////////
+//	Indicates if an edge is valid.
+///////////////////////////////////////////////////////////////////////////////
+int	VMI::isValidEdge(Mesh	*mesh,	int edge)
+{
+	int	result;
+	Vertex	*u;
+	Vertex	*v;
+	_float3_	fu;
+	_float3_	fv;
+
+	u	=	&mesh->vertices[mesh->edges[edge].u];
+	v	=	&mesh->vertices[mesh->edges[edge].v];
+
+	fu	=	_float3_(u->x,u->y,u->z);
+	fv	=	_float3_(v->x,v->y,v->z);
+
+	if ((mVertexMap.find(fu) != mVertexMap.end())
+			||
+			(mVertexMap.find(fv) != mVertexMap.end()))
+	{
+		result	= edge;
+	}
+	//	Edge is not valid.
+	else
+	{
+		result	=	-1;
+	}
+
+	return	result;
+}
+
+//-------------------------------------------------------------------------
+//	Inits the multimap of vertices.
+//-------------------------------------------------------------------------
+void	VMI::initVertexMultimap(Mesh *mesh,multimap<int,int> &vertexMultimap)
+{
+	Vertex	*vertex;
+	float		x,y,z;
+
+	//	Clears multimap of vertices.
+	mVertexMap.clear();
+	mVertices.clear();
+
+	mVertices	=	vertexMultimap;
+
+	//	Debug.
+	cout	<<	"Vertex Map Elements: "
+				<<	mVertices.size()
+				<<	endl;
+
+	//	For each vertex.
+	for (int	i	=	0;	i < mesh->numVertices;	i++)
+	{
+		vertex	=	&mesh->vertices[i];
+
+		x	=	vertex->x;
+		y	=	vertex->y;
+		z	=	vertex->z;
+
+		mVertexMap.insert(t_pair(_float3_(x,y,z),i));
+	}
+}
+
+//-------------------------------------------------------------------------
+//	Deletes a vertex in the multimap.
+//-------------------------------------------------------------------------
+void	VMI::deleteVertexOfMap(Mesh	*mesh, int u)
+{
+	_float3_	removed_vert;
+	t_map_str	lb;
+	t_map_str	ub;
+
+	//	Position of the vertex removed.
+	removed_vert	=	_float3_(	mesh->vertices[u].x,
+														mesh->vertices[u].y,
+														mesh->vertices[u].z);
+
+	//	If position of the removed vertex is found.
+	if (mVertexMap.end() != mVertexMap.find(removed_vert))
+	{
+		lb	=	mVertexMap.lower_bound(removed_vert);
+		ub	=	mVertexMap.upper_bound(removed_vert);
+
+		//	For each vertex.
+		while	(lb != ub)
+		{
+			//	If removed vertex is found.
+			if ((*lb).second == u)
+			{
+				//	Debug.
+				cout	<<	"Vertex erased: "
+							<<	(*lb).second
+							<<	endl;
+
+				//	Delete vertex that disappears.
+				mVertexMap.erase(lb);
+				
+				//	Break while.
+				lb	=	ub;
+			}
+			else
+			{
+				//	Next iteration.
+				lb++;
+			}
+		}
+	}
+}
+
+//-------------------------------------------------------------------------
+//	Compare the coordinates of two vertices.
+//-------------------------------------------------------------------------
+bool	VMI::compareVertices(Vertex *vertices,int	u,	int v)
+{
+	if ((vertices[u].x == vertices[v].x)
+			&&
+			(vertices[u].y == vertices[v].y)
+			&&
+			(vertices[u].z == vertices[v].z))
+	{
+		return	true;
+	}
+	else
+	{
+		return	false;
+	}
+}
+
+//-------------------------------------------------------------------------
+//	Find edge of the simplification sequence.
+//-------------------------------------------------------------------------
+void	VMI::contractInitialMesh(Mesh	*mesh)
+{
+	bool		edge_found;
+	Geometry::MeshSimplificationSequence::Step	step;
+
+	multimap<int,int>::iterator	it0;
+	multimap<int,int>::iterator	lb0;
+	multimap<int,int>::iterator	ub0;
+	multimap<int,int>::iterator	lb1;
+	multimap<int,int>::iterator	ub1;
+
+	std::vector<Geometry::MeshSimplificationSequence::Step> steps;
+
+	Edge		*econ;
+	float		x,y,z;
+	int			*lv1;
+	int			v0;
+	int			v1;
+	int			edge;
+	int			num_edges;
+	Change	*c;
+
+	//	Copy simplification steps of the joined mesh.
+	steps	=	mSequence->mSteps;
+
+	mSequence->mSteps.clear();
+
+	for	(size_t	i	=	0;	i < steps.size(); i++)
+	{
+		step	=	steps[i];
+
+		lb0	=	mVertices.lower_bound(steps[i].mV0);
+		ub0	=	mVertices.upper_bound(steps[i].mV0);
+		lb1	=	mVertices.lower_bound(steps[i].mV1);
+		ub1	=	mVertices.upper_bound(steps[i].mV1);
+
+		edge_found	=	false;
+
+		//	Debug.
+		cout	<<	"step "
+					<<	i
+					<<	" V0: "
+					<<	steps[i].mV0
+					<<	" V1: "
+					<<	steps[i].mV1
+					<<	endl;
+
+		//	Removed vertex.
+		while ((lb1 != ub1) && !edge_found)
+		{
+			//	Real index.
+			v1	=	(*lb1).second;
+
+			lv1	=	edgesAdjToVertex(mesh,v1,&num_edges);
+
+			//	Edje iterator.
+			edge	=	0;
+
+			while	((edge < num_edges) &&	!edge_found)
+			{
+				econ	=	&mesh->edges[lv1[edge]];
+
+				//	Begin of iteration v0.
+				it0	=	lb0;
+
+				//	Remaining vertex.
+				while ((it0 != ub0) &&	!edge_found)
+				{
+					//	Real index.
+					v0	=	(*it0).second;
+					
+					if (compareVertices(mesh->vertices,econ->v,v0))
+					{
+						c = newChange(mesh, econ->u, econ->v);
+
+						edge_found	=	true;
+					}
+					else if (compareVertices(mesh->vertices,econ->u,v0))
+					{
+						c = newChange(mesh, econ->v, econ->u);
+
+						edge_found	=	true;
+					}
+					else
+					{
+						it0++;
+					}
+				}
+
+				edge++;
+			}
+
+			lb1++;
+		}
+
+		if (edge_found)
+		{
+			//	Debug.
+			cout	<<	"Contracting edge of the initial mesh..."	
+						<<	endl
+						<<	"u: "
+						<<	c->u
+						<<	" v: "
+						<<	c->v
+						<<	endl;
+	
+			// Collapse new edge.
+			doChange(mesh, c); // the mesh has been updated.
+
+			// Write Simplification sequence.
+			saveSimplificationSequence(c,0);
+
+			deleteVertexOfMap(mesh, c->u);
+			deleteEdges(mesh, c);
+			modifyEdges(mesh, c);
+			deleteChange(c);
+
+			//	Contract twin vertices.
+			contractTwinVertices(mesh,v1,v0);
+		}
+	}
+}
+
+//-------------------------------------------------------------------------
+//	Find twin vertices and contract them.
+//-------------------------------------------------------------------------
+void VMI::contractTwinVertices(	Mesh	*mesh,
+																int		u,
+																int		v)
+{
+	bool					twin_found;
+	int						edge;
+	int						lonely_vert;
+	int						new_vert;
+	t_map_str			lb;
+	t_map_str			ub;
+	t_map_str			it;
+	_float3_			fu;
+	_float3_			fv;
+	Edge					*econ;
+	float					x,y,z;
+	int						*le;
+	int						num_edges;
+	Change				*c;
+
+	Geometry::GeoVertex	vertex_added;
+
+	if (!compareVertices(mesh->vertices,u,v))
+	{
+		//take_bone_from_vert = v;
+
+		fu	=	_float3_(	mesh->vertices[u].x,
+										mesh->vertices[u].y,
+										mesh->vertices[u].z);
+
+		fv	=	_float3_(	mesh->vertices[v].x,
+										mesh->vertices[v].y,
+										mesh->vertices[v].z);
+
+		//	Find vertices width u coordinates.
+		while ((it = mVertexMap.find(fu)) != mVertexMap.end())
+		{
+			twin_found	=	false;
+
+			lonely_vert	=	(*it).second;
+
+			le	=	edgesAdjToVertex(mesh,lonely_vert,&num_edges);
+
+			//	Find an edge width v coordinates.
+			int	i	=	0;
+
+			while((i < num_edges) && !twin_found)
+			{
+				econ	=	&mesh->edges[le[i]];
+
+				if (compareVertices(mesh->vertices,econ->u,v)
+						||
+						compareVertices(mesh->vertices,econ->v,v))
+				{
+					lb	=	mVertexMap.lower_bound(fv);
+					ub	=	mVertexMap.upper_bound(fv);
+
+					//	For each vertex.
+					while	(lb != ub)
+					{
+						//	If removed vertex is found.
+						if (((*lb).second == econ->u)
+								||
+								((*lb).second == econ->v))
+						{
+							twin_found	=	true;
+
+							//	Break while.
+							lb	=	ub;
+						}
+						else
+						{
+							//	Next iteration.
+							lb++;
+						}
+					}
+				}
+				i++;
+			}
+
+			//	If a twin edge has been found.
+			if (twin_found)
+			{
+				//	Debug.
+				cout	<<	"Twin Collapsed..."	<<	endl;
+
+				//	Compare vertices coordinates.
+				if (compareVertices(mesh->vertices,econ->u,v))
+				{
+					// New edge for the change
+					c = newChange(mesh, econ->v, econ->u);
+
+					//	Debug.
+					cout	<<	"--Reverse--"	<<	endl;
+				}
+				else
+				{
+					// New edge for the change
+					c = newChange (mesh, econ->u, econ->v);
+				}
+
+				// Collapse new edge.
+				doChange(mesh, c); // the mesh has been updated.
+
+				// Write Simplification sequence.
+				saveSimplificationSequence(c,1);
+
+				deleteVertexOfMap(mesh, c->u);
+				deleteEdges(mesh, c);
+				modifyEdges(mesh, c);
+				deleteChange(c);
+			}
+			else
+			{
+				//	Debug.
+				cout	<<	"Collapsing new edge..."	<<	endl;
+
+				x	=	mesh->vertices[v].x;
+				y	=	mesh->vertices[v].y;
+				z	=	mesh->vertices[v].z;
+
+				mesh->vertices = addVertex(	mesh->vertices,
+																		(int *)&mesh->numVertices,
+																		x,
+																		y,
+																		z,
+																		&new_vert);
+				
+				// When a new vertex is added to the mesh, not only the
+				// total number of vertices is increased but also current number
+				mesh->currentNumVertices++;
+
+				//	Adds new vertex to multimap.
+				mVertexMap.insert(t_pair(_float3_(x,y,z),new_vert));
+
+				//	Creates new edge.
+				mesh->edges	=	addEdge(mesh->edges,
+															(int *)&mesh->numEdges,
+															lonely_vert,
+															new_vert,
+															&edge);
+
+				/*
+				//	Debug.
+				cout	<<	"lonely_vert"
+					<<	lonely_vert
+					<<	"("
+					<<	mesh->vertices[lonely_vert].x
+					<<	","
+					<<	mesh->vertices[lonely_vert].y
+					<<	","
+					<<	mesh->vertices[lonely_vert].z
+					<<	")"
+					<<	endl;
+				//	Debug.
+				cout	<<	"new_vert"
+					<<	new_vert
+					<<	"("
+					<<	mesh->vertices[new_vert].x
+					<<	","
+					<<	mesh->vertices[new_vert].y
+					<<	","
+					<<	mesh->vertices[new_vert].z
+					<<	")"
+					<<	endl;
+				*/
+
+				//	We assume here there are the same number of vertices
+				//	and texture coordinates and normals.
+
+				//	Assigns the position of the vertex.
+				vPositions.push_back(Geometry::Vector3(x,y,z));
+
+				//	Assigns a texture coordinate for the vertex.
+				vTexCoords.push_back(vTexCoords[lonely_vert]);
+
+				//	Assigns a normal coordinate for the vertex.
+				vNormals.push_back(vNormals[lonely_vert]);
+
+				//	Adds new vertex information to simplification sequence.
+				vertex_added.id				=	new_vert;
+				vertex_added.bonefrom	=	v;
+
+				vertex_added.position	=	vPositions[new_vert];
+
+				vertex_added.texcoord	=	vTexCoords[new_vert];
+
+				vertex_added.normal	=	vNormals[new_vert];
+
+				mSequence->mNewVertices.push_back(vertex_added);
+
+				// Collapse new edge
+				c = newChange(mesh, lonely_vert, new_vert);
+
+				doChange(mesh, c); // the mesh has been updated
+
+				// Write Simplification sequence.
+				saveSimplificationSequence(c,1);
+
+				deleteVertexOfMap(mesh, c->u);
+				deleteEdges(mesh, c);
+				modifyEdges(mesh, c);
+				deleteChange(c);
+			}
+		}
+	}
+}
+
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/histogram.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/histogram.cpp	(revision 983)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/histogram.cpp	(revision 2090)
@@ -9,4 +9,6 @@
 #include "../include/histogram.h"
 #include "../include/metrics.h"
+
+#define WIN_MARGIN 2
 
 using namespace VMI;
@@ -185,7 +187,199 @@
 }
 
+void VMI::getBoundingBox(Change *c, GLfloat min[3], GLfloat max[3]) {
+    GLuint  i, j, t, v;
+    GLfloat maxx = 0.0f, minx = 0.0f, 
+            maxy = 0.0f, miny = 0.0f,
+            maxz = 0.0f, minz = 0.0f;
+    
+    /* get the max/mins */
+    for (i=0; i<(GLuint)c->numMod; i++) {
+        t = c->modified[i].id;
+        
+        for (j=0; j<3; j++) {
+            v = mesh->triangles[t].indices[j];
+            // v
+            if (maxx < mesh->vertices[v].x)
+                maxx = mesh->vertices[v].x;
+            if (minx > mesh->vertices[v].x)
+                minx = mesh->vertices[v].x;
+            
+            if (maxy < mesh->vertices[v].y)
+                maxy = mesh->vertices[v].y;
+            if (miny > mesh->vertices[v].y)
+                miny = mesh->vertices[v].y;
+            
+            if (maxz < mesh->vertices[v].z)
+                maxz = mesh->vertices[v].z;
+            if (minz > mesh->vertices[v].z)
+                minz = mesh->vertices[v].z;
+        }
+    }
+
+    for (i=0; i<(GLuint)c->numDel; i++) {
+        t = c->deleted[i].id;
+        
+        for (j=0; j<3; j++) {
+            v = mesh->triangles[t].indices[j];
+            // v
+            if (maxx < mesh->vertices[v].x)
+                maxx = mesh->vertices[v].x;
+            if (minx > mesh->vertices[v].x)
+                minx = mesh->vertices[v].x;
+            
+            if (maxy < mesh->vertices[v].y)
+                maxy = mesh->vertices[v].y;
+            if (miny > mesh->vertices[v].y)
+                miny = mesh->vertices[v].y;
+            
+            if (maxz < mesh->vertices[v].z)
+                maxz = mesh->vertices[v].z;
+            if (minz > mesh->vertices[v].z)
+                minz = mesh->vertices[v].z;
+        }
+    }
+
+    min[0] = minx;
+    min[1] = miny;
+    min[2] = minz;
+
+    max[0] = maxx;
+    max[1] = maxy;
+    max[2] = maxz;
+}
+
+void VMI::getWindow(GLfloat min[3], GLfloat max[3], int minw[2], int maxw[2]) {
+    GLdouble winx, winy, winz,
+             mv[16], pm[16];
+    GLint vp[4], minx, miny, maxx, maxy;
+
+    glGetDoublev(GL_MODELVIEW_MATRIX, mv);
+    glGetDoublev(GL_PROJECTION_MATRIX, pm);
+    glGetIntegerv(GL_VIEWPORT, vp);
+    
+    /* The eight points of the bounding box */
+    /* Point 1 (min,min,min) */
+    gluProject((GLdouble)min[0], (GLdouble)min[1], (GLdouble)min[2], mv, pm, vp, &winx, &winy, &winz);
+    minx = winx;
+    maxx = winx;
+    miny = winy;
+    maxy = winy;
+
+    /* Point 2 (max,min,min) */
+    gluProject((GLdouble)max[0], (GLdouble)min[1], (GLdouble)min[2], mv, pm, vp, &winx, &winy, &winz);
+    if (winx < minx) minx =winx;
+    if (winx > maxx) maxx =winx;
+    if (winy < miny) miny =winy;
+    if (winy > maxy) maxy =winy;
+
+    /* Point 3 (min,max,min) */
+    gluProject((GLdouble)min[0], (GLdouble)max[1], (GLdouble)min[2], mv, pm, vp, &winx, &winy, &winz);
+    if (winx < minx) minx =winx;
+    if (winx > maxx) maxx =winx;
+    if (winy < miny) miny =winy;
+    if (winy > maxy) maxy =winy;
+
+    /* Point 4 (max,max,min) */
+    gluProject((GLdouble)max[0], (GLdouble)max[1], (GLdouble)min[2], mv, pm, vp, &winx, &winy, &winz);
+    if (winx < minx) minx =winx;
+    if (winx > maxx) maxx =winx;
+    if (winy < miny) miny =winy;
+    if (winy > maxy) maxy =winy;
+
+    /* Point 5 (min,min,max) */
+    gluProject((GLdouble)min[0], (GLdouble)min[1], (GLdouble)max[2], mv, pm, vp, &winx, &winy, &winz);
+    if (winx < minx) minx =winx;
+    if (winx > maxx) maxx =winx;
+    if (winy < miny) miny =winy;
+    if (winy > maxy) maxy =winy;
+
+    /* Point 6 (max,min,max) */
+    gluProject((GLdouble)max[0], (GLdouble)min[1], (GLdouble)max[2], mv, pm, vp, &winx, &winy, &winz);
+    if (winx < minx) minx =winx;
+    if (winx > maxx) maxx =winx;
+    if (winy < miny) miny =winy;
+    if (winy > maxy) maxy =winy;
+
+    /* Point 7 (min,max,max) */
+    gluProject((GLdouble)min[0], (GLdouble)max[1], (GLdouble)max[2], mv, pm, vp, &winx, &winy, &winz);
+    if (winx < minx) minx =winx;
+    if (winx > maxx) maxx =winx;
+    if (winy < miny) miny =winy;
+    if (winy > maxy) maxy =winy;
+
+    /* Point 8 (max,max,max) */
+    gluProject((GLdouble)max[0], (GLdouble)max[1], (GLdouble)max[2], mv, pm, vp, &winx, &winy, &winz);
+    if (winx < minx) minx =winx;
+    if (winx > maxx) maxx =winx;
+    if (winy < miny) miny =winy;
+    if (winy > maxy) maxy =winy;
+
+    minw[0] = minx;
+    minw[1] = miny;
+
+    maxw[0] = maxx;
+    maxw[1] = maxy;
+}
+
+void VMI::getSWHistogramWin(GLuint *histogram, GLubyte *pixels, GLfloat min[3], GLfloat max[3], Change *c) {
+    GLubyte r, g, b, a;
+    GLuint i, t, p, numPixels,
+          *histoAux = (GLuint *)calloc(mesh->numTriangles + 1, sizeof(GLuint));
+    GLint minw[2], maxw[2], ox, oy, h, w;
+
+    getWindow(min, max, minw, maxw);
+
+    w = ABS(maxw[0] - minw[0]);
+    h = ABS(maxw[1] - minw[1]);
+    //printf("w:%d h:%d\n", w, h);
+
+    ox = minw[0];
+    oy = minw[1];
+
+    ox -= WIN_MARGIN;
+    if (ox < 0)  ox = 0;
+    oy -= WIN_MARGIN;
+    if (oy < 0)  oy = 0;
+
+    w += (WIN_MARGIN * 2);
+    if (w > width)  w = width;
+    h += (WIN_MARGIN * 2);
+    if (h > height) h = height;
+
+    //printf("(%d,%d)\n", ox, oy);
+    //printf("w:%d h:%d\n", w, h);
+    //getchar();
+
+    numPixels = w * h;
+    //printf("NumPixels: %d\n", numPixels);
+
+    glReadPixels(ox, oy, w, h, GL_RGBA, GL_UNSIGNED_BYTE, pixels);
+
+    for (i=0; i<numPixels; i++) { // pixel i
+        p = i << 2; // 4 * i
+        r = pixels[p];
+        g = pixels[p + 1];
+        b = pixels[p + 2];
+        a = pixels[p + 3];
+
+        t = r + (g << 8) + (b << 16) + (a << 24); // triangle color
+        //printf("pixel:%d (%d,%d,%d,%d) t %d\n", i, r, g, b, a, t);
+
+        histoAux[t]++;   
+    }
+
+    for (i=0; i<(GLuint)c->numMod; i++) {
+        t = (GLuint)c->modified[i].id;
+
+        histogram[t + 1] = histoAux[t + 1]; 
+    }
+
+    free(histoAux);
+    //getchar();
+}
+
 void VMI::getSWHistoByOcclusionQuery(Mesh *mesh, Color *colors, GLuint *histogram) {
     GLuint i, v1, v2, v3;
-    GLint area;
+    GLint area, totalArea = 0;
 
     glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);
@@ -196,5 +390,5 @@
             glBeginQueryARB(GL_SAMPLES_PASSED_ARB, queries[i]);
             
-            // Render triangle i
+            /* Render triangle i */
             glBegin(GL_TRIANGLES);
             v1= mesh->triangles[i].indices[0];
@@ -226,9 +420,14 @@
             } else {
                 histogram[i + 1] = area;
+
+                totalArea += area;
             }
         }
     }
-    histogram[0] = computeBackgroundArea(mesh, histogram); // Compute area of the background
-
+
+    /* Compute the background area */
+    histogram[0] = (width * height) - totalArea;
+
+    //printf("background area: %d\n", histogram[0]);
 }
 
Index: GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshViewUI.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshViewUI.h	(revision 1554)
+++ GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshViewUI.h	(revision 2090)
@@ -88,4 +88,6 @@
 using	namespace	std;
 
+//-----------------------------------------------------------------------------
+//-----------------------------------------------------------------------------
 class GeoToolIndexData : public Geometry::IndexData
 {
@@ -131,4 +133,7 @@
 };
 
+//-----------------------------------------------------------------------------
+//	Class User Interface of GeoTool.
+//-----------------------------------------------------------------------------
 class GeoMeshViewUI
 {
@@ -198,4 +203,6 @@
 	inline void cb_menuRenderSolid_i(fltk::Item*, void*);
 	static void cb_menuRenderSolid(fltk::Item*, void*);
+	inline void cb_menuRenderLighting_i(fltk::Item*, void*);
+	static void cb_menuRenderLighting(fltk::Item*, void*);
 	inline void cb_menuRenderCW_i(fltk::Item*, void*);
 	static void cb_menuRenderCW(fltk::Item*, void*);
@@ -361,4 +368,5 @@
 	fltk::Item					*menuRenderWire;
 	fltk::Item					*menuRenderSolid;
+	fltk::Item					*menuRenderLighting;
 	fltk::Item					*menuRenderCW;
 	fltk::Item					*menuRenderCCW;
Index: GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshView.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshView.h	(revision 1549)
+++ GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshView.h	(revision 2090)
@@ -34,4 +34,5 @@
 	bool		mWire;
 	bool		mSolid;
+	bool		mLighting;
 	bool		mCW;
 	bool		mCCW;
@@ -95,4 +96,8 @@
 	void	activeSolid(){mSolid	=	true;};
 	void	deactiveSolid(){mSolid	=	false;};
+
+	//	Lighting.
+	void	activeLighting(){mLighting	=	true;};
+	void	deactiveLighting(){mLighting	=	false;};
 
 	//	Clockwise mode.
